// Flashing light script, loosely based off some other script that moved objects for indicators!
// Not sure how elegant this if/else if process is to control flashing lights?
// Wouldn't it be nice to just access a shader variable? Perhaps ramp transparency vs time, or just turn it on/off?
// Hint hint Ruud, Onyx/qscript to be able to access shader variables? :-D

rcar $car = get local car

rcarmodel $flash1 = get generic model 1 of $car
rcarmodel $flash2 = get generic model 2 of $car
set $flash1 scriptcontrolled 1
set $flash2 scriptcontrolled 1

int $flashPressed = 0
int $flashToggle = 0
int $timeOn


// A nice toggle script for the input key feature state
func void input()
{
	if is key 81 pressed		//Turn on flashing key Q
	{
		if $flashPressed == 0
		{
			$flashPressed = 1		//Mark as pressed
			if $flashToggle == 1
			{
				$flashToggle = 0
			}
			else 
			{
				$flashToggle = 1
				$timeOn = 0
			}
		}
	}
	else
	{
		$flashPressed = 0			//Mark as released
	}
}

//Flash!
func void flash()
{
	if $flashToggle == 1
	{
		//If we want to flash, set a timer going to control when flashes happen
		$timeOn += 1
		if $timeOn < 1
		{
			set $flash1 position float[3]{0,-5,0}
			set $flash2 position float[3]{0,-5,0}
		}
		else if $timeOn < 4
		{
			set $flash1 position float[3]{0,0,0}
		}
		else if $timeOn < 10
		{
			set $flash1 position float[3]{0,-5,0}
		}
		else if $timeOn < 13
		{
			set $flash1 position float[3]{0,0,0}
		}
		else if $timeOn < 19
		{
			set $flash1 position float[3]{0,-5,0}
		}
		else if $timeOn < 34
		{
			set $flash2 position float[3]{0,-5,0}
		}
		else if $timeOn < 35
		{
			set $flash2 position float[3]{0,0,0}
		}
		else if $timeOn < 38
		{
			set $flash2 position float[3]{0,-5,0}
		}
		else if $timeOn < 41
		{
			set $flash2 position float[3]{0,0,0}
		}
		else if $timeOn < 47
		{
			set $flash2 position float[3]{0,-5,0}
		}
		else if $timeOn < 50
		{
			set $flash1 position float[3]{0,-5,0}
			set $flash2 position float[3]{0,-5,0}
		}
		else if $timeOn == 50
		{
			//When we get to 50, start again!
			$timeOn = 0
		}
	}
	//If we are not flashing, move these objects 5m under the car (usually under the ground!) Mega hack or what :-D
	else
	{
		set $flash1 position float[3]{0,-5,0}
		set $flash2 position float[3]{0,-5,0}	
	}
}

while 1
{
	input()
	flash()
  
	interrupt
}