// Launch control script for the 5.0 Gallardo.
// Put the car in neutral while stationary and floor it, when the pedal is pressed hard and the revs reach 6250rpm, the clutch is dumped and away you go!

rcar $car=get scriptowner car

shared int $TCS

float $throttle
float $speed
float $rpm
float $gear
int $currentGear

int $varLC

while 1
{
	//CONTROL STATES
	$throttle = get $car throttle
	$gear = get $car gear
	
	//CAR STATES
	$speed = get $car tachovelocity
	$rpm = get $car rpm
	
	//ENABLE LC IN THESE CONDITIONS
	if $speed < 0.1 and $gear == 0 and $TCS == 0
	{	
		$varLC = 1
		set $car gear 0
	}
	else
	{
		$varLC = 0
	}
	
	//EXECUTING LC IN THESE CONDITIONS (90% or more throttle, 6250rpm+)
	if $varLC == 1 and $rpm > 6250 and $throttle > 0.9
	{
		set $car gear 2
		$varLC = 0
	}

	// Wait every 50ms before running this script, there really is no need for it to run EVERY physics step
	wait 50
	
	interrupt
}